// PBOToolDlg.cpp : implementation file
//

#include "stdafx.h"
#include <direct.h>
#include "PBOTool.h"
#include "PBOToolDlg.h"
#include "pbopack.h"
#include "getfolder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPBOToolDlg dialog

CPBOToolDlg::CPBOToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPBOToolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPBOToolDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPBOToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPBOToolDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPBOToolDlg, CDialog)
	//{{AFX_MSG_MAP(CPBOToolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXTRACT, OnExtract)
	ON_BN_CLICKED(IDC_COMPRESS, OnCompress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPBOToolDlg message handlers


static   CWnd  *thisWnd=0;


BOOL CPBOToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
   thisWnd=this;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPBOToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPBOToolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPBOToolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

const    char  *PBOExt="PBO files\0*.pbo\0";

void CPBOToolDlg::OnExtract() 
{
   PboPack pack;

   
   char path[256];
   GetCurrentDirectory(256,path);

   CFileDialog OpenFile(TRUE, 0,0,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,0,this);

   OpenFile.m_ofn.lpstrTitle="Extract file...";

   OpenFile.m_ofn.lpstrFilter=PBOExt;

   OpenFile.m_ofn.lpstrInitialDir=path;

   OpenFile.m_ofn.nFileExtension=1;

   int ret=OpenFile.DoModal();

   if (ret==1)
   {
      pack.Extract(OpenFile.GetFileName());
   }   
}




void CPBOToolDlg::OnCompress() 
{
   PboPack pack;
  
   char path[256];

   GetCurrentDirectory(256,path);   
      
   string   pathname;

   int ret = GetFolder(pathname, "Compress folder..",m_hWnd,"",path);   

   if (ret!=1)
      return;
   
   CFileDialog SaveFile(FALSE, 0,0,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,0,this);

   SaveFile.m_ofn.lpstrTitle="Save to...";

   SaveFile.m_ofn.lpstrInitialDir=path;

   SaveFile.m_ofn.lpstrFilter=PBOExt;
   
   ret=SaveFile.DoModal();

   if (ret==1)
   {      
      pack.Compress(SaveFile.GetFileName(),pathname.c_str());
   }   	   
}




void     PrintConsole(const char *str,...)
{
   va_list ap;

   char buffer[2048];

   va_start(ap,str);

   vsprintf(buffer,str,ap);
   va_end(ap);	

   OutputDebugString(buffer);

   CWnd  *pEdit=thisWnd->GetDlgItem(IDC_CONSOLE);

   CString  etext;

   pEdit->GetWindowText(etext);

   int len=strlen(buffer);

   for (int i=0;i<len;i++)
   {  
      int c=buffer[i];

      if (c=='\n')
      {
         etext+=TCHAR(13);
         etext+=TCHAR(10);
      }
      else
         etext+=TCHAR(c);
   }

   pEdit->SetWindowText(etext);

   SendMessage(pEdit->m_hWnd,EM_LINESCROLL,0,SendMessage(pEdit->m_hWnd,EM_GETLINECOUNT,0,0));

   thisWnd->UpdateWindow();
}
